## ros-eloquent-rclpy 0.8.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclpy C)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(rcl REQUIRED)
find_package(rcl_action REQUIRED)
find_package(rcl_yaml_param_parser REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)

find_package(python_cmake_module REQUIRED)
find_package(PythonExtra MODULE REQUIRED)

set(_PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE}")

if(WIN32 AND CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE_DEBUG}")
endif()

# enables using the Python extensions from the build space for testing
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/test_rclpy/__init__.py" "")

ament_python_install_package(${PROJECT_NAME})

function(set_properties _targetname _build_type)
  set_target_properties(${_targetname} PROPERTIES
    PREFIX ""
    LIBRARY_OUTPUT_DIRECTORY${_build_type} "${CMAKE_CURRENT_BINARY_DIR}/test_${PROJECT_NAME}"
    RUNTIME_OUTPUT_DIRECTORY${_build_type} "${CMAKE_CURRENT_BINARY_DIR}/test_${PROJECT_NAME}"
    OUTPUT_NAME "_${_targetname}${PythonExtra_EXTENSION_SUFFIX}"
    SUFFIX "${PythonExtra_EXTENSION_EXTENSION}")
endfunction()

# Only build the library if a C typesupport exists
get_rmw_typesupport(typesupport_impls "rmw_implementation" LANGUAGE "c")
if(typesupport_impls STREQUAL "")
  message(STATUS "Skipping rclpy because no C typesupport library was found.")
  return()
endif()

function(configure_python_c_extension_library _library_name)
  set_properties(${_library_name} "")
  if(WIN32)
    set_properties(${_library_name} "_DEBUG")
    set_properties(${_library_name} "_MINSIZEREL")
    set_properties(${_library_name} "_RELEASE")
    set_properties(${_library_name} "_RELWITHDEBINFO")
  endif()

  target_link_libraries(${_library_name}
    ${PythonExtra_LIBRARIES}
  )

  ament_target_dependencies(${_library_name}
    "PythonExtra"
  )

  install(TARGETS ${_library_name}
    DESTINATION "${PYTHON_INSTALL_DIR}/${PROJECT_NAME}"
  )
endfunction()

add_library(rclpy_common
  SHARED src/rclpy_common/src/common.c
)
target_link_libraries(rclpy_common
  ${PythonExtra_LIBRARIES}
)
target_include_directories(rclpy_common
  PUBLIC
  src/rclpy_common/include
)
ament_target_dependencies(rclpy_common
  "rcl"
  "rmw"
  "PythonExtra"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(rclpy_common PRIVATE "RCLPY_COMMON_BUILDING_DLL")

install(TARGETS rclpy_common
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

add_library(
  rclpy
  SHARED src/rclpy/_rclpy.c
)
target_link_libraries(rclpy
  rclpy_common
)

configure_python_c_extension_library(rclpy)
ament_target_dependencies(rclpy
  "rcl"
  "rcl_yaml_param_parser"
  "rcutils"
)

add_library(
  rclpy_action
  SHARED src/rclpy/_rclpy_action.c
)
target_link_libraries(rclpy_action
  rclpy_common
)

configure_python_c_extension_library(rclpy_action)
ament_target_dependencies(rclpy_action
  "rcl"
  "rcl_action"
  "rcutils"
)

# Logging support provided by rcutils
add_library(
  rclpy_logging
  SHARED src/rclpy/_rclpy_logging.c
)
configure_python_c_extension_library(rclpy_logging)
ament_target_dependencies(rclpy_logging
  "rcutils"
)

# Signal handling library
add_library(
  rclpy_signal_handler
  SHARED src/rclpy/_rclpy_signal_handler.c
)
configure_python_c_extension_library(rclpy_signal_handler)
ament_target_dependencies(rclpy_signal_handler
  "rcl"
  "rcutils"
)

# Pycapsule handling library
add_library(
  rclpy_pycapsule
  SHARED src/rclpy/_rclpy_pycapsule.c
)
configure_python_c_extension_library(rclpy_pycapsule)

if(NOT WIN32)
  ament_environment_hooks(
    "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
  )
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_pytest REQUIRED)

  rosidl_generator_py_get_typesupports(_typesupport_impls)
  ament_index_get_prefix_path(ament_index_build_path SKIP_AMENT_PREFIX_PATH)
  # Get the first item (it will be the build space version of the build path).
  list(GET ament_index_build_path 0 ament_index_build_path)
  if(WIN32)
    # On Windows prevent CMake errors and prevent it being evaluated as a list.
    string(REPLACE "\\" "/" ament_index_build_path "${ament_index_build_path}")
  endif()
  if(NOT _typesupport_impls STREQUAL "")

  # Run each test in its own pytest invocation to isolate any global state in rclpy
  set(_rclpy_pytest_tests
    test/test_action_client.py
    test/test_action_graph.py
    test/test_action_server.py
    test/test_callback_group.py
    test/test_client.py
    test/test_clock.py
    test/test_create_node.py
    test/test_create_while_spinning.py
    test/test_destruction.py
    test/test_executor.py
    test/test_expand_topic_name.py
    test/test_guard_condition.py
    test/test_handle.py
    test/test_init_shutdown.py
    test/test_logging.py
    test/test_messages.py
    test/test_node.py
    test/test_parameter.py
    test/test_parameters_callback.py
    test/test_qos.py
    test/test_qos_event.py
    test/test_rate.py
    test/test_task.py
    test/test_time_source.py
    test/test_time.py
    test/test_timer.py
    test/test_topic_or_service_is_hidden.py
    test/test_utilities.py
    test/test_validate_full_topic_name.py
    test/test_validate_namespace.py
    test/test_validate_node_name.py
    test/test_validate_topic_name.py
    test/test_waitable.py
  )

  foreach(_test_path ${_rclpy_pytest_tests})
    get_filename_component(_test_name ${_test_path} NAME_WE)
    ament_add_pytest_test(${_test_name} ${_test_path}
      PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE}"
      APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}
        PYTHONPATH=${CMAKE_CURRENT_BINARY_DIR}
      TIMEOUT 120
      WERROR ON
    )
  endforeach()
  endif()
endif()
set(PYTHON_EXECUTABLE "${_PYTHON_EXECUTABLE}")

ament_package()

=== debian/changelog ===
ros-eloquent-rclpy (0.8.5-1bionic) bionic; urgency=high

  * fix moved troubleshooting url (#579 <https://github.com/ros2/rclpy/issues/579>) (#589 <https://github.com/ros2/rclpy/issues/589>)
  * improve error message if rclpy C extensions are not found (#580 <https://github.com/ros2/rclpy/issues/580>) (#591 <https://github.com/ros2/rclpy/issues/591>)
  * Contributors: Dirk Thomas

 -- William Woodall <william@osrfoundation.org>  Fri, 04 Dec 2020 06:00:00 -0000

ros-eloquent-rclpy (0.8.4-1bionic) bionic; urgency=high

  * Guard against unexpected action responses (#474 <https://github.com/ros2/rclpy/issues/474>) (#476 <https://github.com/ros2/rclpy/issues/476>)
  * Send feedback callbacks properly in send_goal() of action client (#451 <https://github.com/ros2/rclpy/issues/451>) (#465 <https://github.com/ros2/rclpy/issues/465>)
  * Contributors: Jacob Perron, Werner Neubauer

 -- William Woodall <william@osrfoundation.org>  Fri, 17 Jan 2020 06:00:00 -0000

ros-eloquent-rclpy (0.8.3-1bionic) bionic; urgency=high

  * Future invokes done callbacks when done (#461 <https://github.com/ros2/rclpy/issues/461>)
  * Make short key of a QoS policy accessible (#463 <https://github.com/ros2/rclpy/issues/463>)
  * Fix new linter warnings as of flake8-comprehensions 3.1.0 (#462 <https://github.com/ros2/rclpy/issues/462>)
  * Contributors: Dirk Thomas, Shane Loretz

 -- William Woodall <william@osrfoundation.org>  Mon, 18 Nov 2019 06:00:00 -0000

ros-eloquent-rclpy (0.8.2-1bionic) bionic; urgency=high

  * Explicitly destroy a node's objects before the node. (#456 <https://github.com/ros2/rclpy/issues/456>)
  * Get proper parameters with prefixes without dot separator. (#455 <https://github.com/ros2/rclpy/issues/455>)
  * Fix import to use builtin_interfaces.msg (#453 <https://github.com/ros2/rclpy/issues/453>)
  * Add missing exec depend on rcl_interfaces (#452 <https://github.com/ros2/rclpy/issues/452>)
  * Contributors: Brian Marchi, Dirk Thomas, Steven! Ragnarök

 -- William Woodall <william@osrfoundation.org>  Wed, 13 Nov 2019 06:00:00 -0000

ros-eloquent-rclpy (0.8.1-1bionic) bionic; urgency=high

  * Fix the unicode test string for opensplice rmw implementation (#447 <https://github.com/ros2/rclpy/issues/447>)
  * Expand test timeout to deflake rmw_connext (#449 <https://github.com/ros2/rclpy/issues/449>)
  * Support array parameter types (#444 <https://github.com/ros2/rclpy/issues/444>)
  * Make use of Clock class for throttling logs (#441 <https://github.com/ros2/rclpy/issues/441>)
  * Drop rclpy test_remove_ros_args_empty test case. (#445 <https://github.com/ros2/rclpy/issues/445>)
  * Add Rate (#443 <https://github.com/ros2/rclpy/issues/443>)
  * Action server: catch exception from user execute callback (#437 <https://github.com/ros2/rclpy/issues/437>)
  * Make cppcheck happy (#438 <https://github.com/ros2/rclpy/issues/438>)
  * Contributors: Brian Marchi, Jacob Perron, Michael Carroll, Michel Hidalgo, Shane Loretz

 -- William Woodall <william@osrfoundation.org>  Wed, 23 Oct 2019 05:00:00 -0000

ros-eloquent-rclpy (0.8.0-1bionic) bionic; urgency=high

  * Take parameter overrides provided through the CLI. (#434 <https://github.com/ros2/rclpy/issues/434>)
  * Changelog version to master (#410 <https://github.com/ros2/rclpy/issues/410>)
  * Remove deprecated QoS functionality (#431 <https://github.com/ros2/rclpy/issues/431>)
  * Remove comment (#432 <https://github.com/ros2/rclpy/issues/432>)
  * Provide subscription count from Publisher #418 <https://github.com/ros2/rclpy/issues/418> (#429 <https://github.com/ros2/rclpy/issues/429>)
  * Raise custom error when node name is not found (#413 <https://github.com/ros2/rclpy/issues/413>)
  * Timer uses ROS time by default (#419 <https://github.com/ros2/rclpy/issues/419>)
  * Fix _rclpy.c formatting. (#421 <https://github.com/ros2/rclpy/issues/421>)
  * Fail on invalid and unknown ROS specific arguments (#415 <https://github.com/ros2/rclpy/issues/415>)
  * Force explicit --ros-args in cli args. (#416 <https://github.com/ros2/rclpy/issues/416>)
  * Make Future result() and __await__ raise exceptions (#412 <https://github.com/ros2/rclpy/issues/412>)
  * Use of -r/--remap flags where appropriate. (#411 <https://github.com/ros2/rclpy/issues/411>)
  * Awake waitables on shutdown, check if context is valid (#403 <https://github.com/ros2/rclpy/issues/403>)
  * Accept tuples as parameter arrays (#389 <https://github.com/ros2/rclpy/issues/389>)
  * Adapt to '--ros-args ... [--]'-based ROS args extraction (#405 <https://github.com/ros2/rclpy/issues/405>)
  * Replace 'NULL == ' with ! (#404 <https://github.com/ros2/rclpy/issues/404>)
  * Declaring 'use_sim_time' when attaching node to time source. (#396 <https://github.com/ros2/rclpy/issues/396>)
  * Adding ignore_override parameter to declare_parameter(s). (#392 <https://github.com/ros2/rclpy/issues/392>)
  * fix missing 'raise'
  * Adding get_parameters_by_prefix method to Node. (#386 <https://github.com/ros2/rclpy/issues/386>)
  * remove whitespace (#385 <https://github.com/ros2/rclpy/issues/385>)
  * Added clients by node implementation from rcl (#383 <https://github.com/ros2/rclpy/issues/383>)
  * Fix time conversion for a big nanoseconds value (#384 <https://github.com/ros2/rclpy/issues/384>)
  * Allowing parameter declaration without a given value. (#382 <https://github.com/ros2/rclpy/issues/382>)
  * Make flake8 happy on windows (#381 <https://github.com/ros2/rclpy/issues/381>)
  * Rename QoS*Policy enum's to *Policy (#379 <https://github.com/ros2/rclpy/issues/379>)
  * Fixing namespace expansion for declare_parameters. (#377 <https://github.com/ros2/rclpy/issues/377>)
  * Use params from node '/**' from parameter YAML file (#370 <https://github.com/ros2/rclpy/issues/370>)
  * [executors] don't convert a timeout_sec to nsecs (#372 <https://github.com/ros2/rclpy/issues/372>)
  * Fix API documentation related to ROS graph methods (#366 <https://github.com/ros2/rclpy/issues/366>)


=== debian/control ===
Source: ros-eloquent-rclpy
Section: misc
Priority: optional
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), python3-pytest, ros-eloquent-ament-cmake, ros-eloquent-ament-cmake-pytest, ros-eloquent-ament-lint-auto, ros-eloquent-ament-lint-common, ros-eloquent-python-cmake-module, ros-eloquent-rcl, ros-eloquent-rcl-action, ros-eloquent-rcl-yaml-param-parser, ros-eloquent-rcutils, ros-eloquent-rmw-implementation, ros-eloquent-rmw-implementation-cmake, ros-eloquent-rosidl-generator-py, ros-eloquent-test-msgs, ros-eloquent-unique-identifier-msgs, ros-eloquent-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-eloquent-rclpy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-eloquent-ament-index-python, ros-eloquent-builtin-interfaces, ros-eloquent-rcl, ros-eloquent-rcl-action, ros-eloquent-rcl-interfaces, ros-eloquent-rcl-yaml-param-parser, ros-eloquent-rmw-implementation, ros-eloquent-rosgraph-msgs, ros-eloquent-unique-identifier-msgs, ros-eloquent-ros-workspace
Description: Package containing the Python client.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/eloquent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/eloquent" \
		-DAMENT_PREFIX_PATH="/opt/ros/eloquent" \
		-DCMAKE_PREFIX_PATH="/opt/ros/eloquent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-eloquent-rclpy//opt/ros/eloquent/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_install
